$(function() {
	preLoadImage( "zoomButtonHover.png" );

	readSettingFromSearch();

	addStyleRule( "#selectTable { height: "+tableHeight+"px  !important; }" );
	addStyleRule( "#selectTable { width: "+tableWidth+"px  !important; }" );
	
	initTable_yokutsukau();
	initTable();
	initSelect();
	
	var userCommandBoxWidth = parseInt($("#buttonBox2").width())+parseInt($("#buttonBox3").width())+parseInt($("#buttonBox4").width());
	addStyleRule( "#userCommandBox { width: "+userCommandBoxWidth+"px  !important; }" );
	$("#userCommandBox").html(userCommandHTML);
	addStyleRule( "#historyBox { width: "+userCommandBoxWidth+"px  !important; }" );
	$("#historyBox").html(historyHTML);
	
	doCommand("registHistory:NO");

	$("#screenButton").css("display","none");
	
	if( screenNum != 1 )
	{
		var screenHTML = "";
		screenHTML += '<span class="screenButton2" onclick="changeScreen2(\'A\')" id="screenButtonA">A</span>';
		screenHTML += '<span class="screenButton2" onclick="changeScreen2(\'N\')" id="screenButtonN">N</span>';
		
		if( screenNum >= 3 )
		screenHTML += '<span class="screenButton2" onclick="changeScreen2(\'P\')" id="screenButtonP">P</span>';
		
		for( i=1 ; i <= screenNum ; i++ )
		{
			screenHTML += '<span class="screenButton2" onclick="changeScreen2(\''+i+'\')" id="screenButton'+i+'">'+i+'</span>';
		} 
		
		$("#screenSelectBox").html(screenHTML);
	}
	changeScreen2( selectScreen );
	
	initWindowSize();
	
	isReadyTable = true;
	
	// ウインドウをずらす座標
	var pos = findPos( document.getElementById("selectTable") );
	var x = Math.floor( pos[0] + cellWidth / 2 );
	var y = Math.floor( pos[1] + cellHeight / 2 );
	
	

	doCommand("setwindowposition:"+x+","+y);
});

//サイズ選択の縦横のセルの数
var yokoNum = 6;
var tateNum = 6;

var gridYoko = 2;
var gridTate = 2;

var cellWidth = 24;
var cellHeight = 18;

var tableWidth = 170;
var tableHeight = 125;

var shortcutWidth = 24;
var shortcutHeight = 20;

var historyHTML = "";

var isPresetButtonToIcon = 0;

var screenNum = 2;
var shortScrrenNameToLongScreenNameHash = { "a" : "auto", "n" : "next", "p": "prev", "c" : "current", "d" : "default" };
var selectScreen = "A";

var cellColor = "#8280ff"; //"#ffffff"; //
var cellDefaultColor ="#ffffff"; // "#000000"; //
var cellCancelColor = "#ff8082"



var argvHash = 0;

var isReadyTable = false;

var userCommandHTML = '';


// テーブル内のセルを２次元配列にする
// この配列を碁盤の要領で利用する
var objList = new Array();
// ドラッグ中かどうか
var isDrag = false;
// ドラッグ中の背景色
var dragColor = cellColor;
// ドラッグ開始の座標
var startX;
var startY;

var endX;
var endY;

var preThis = 0;

var flag = 0, sRow, sCell, sFor = 0, eFor = 0;
var Col_def = '', Col_sel = cellColor, Col_S = dragColor, Col_D =dragColor;


var closeTimmer = 0;
var colorToDontActionTimmer = 0;

var isDoResizeAction = 0;
var checkTime = 1000;


function readSettingFromSearch()
{
	var inSearch = parent.location.search;
	var q = new Object();
	if( inSearch )
	{
		var allArray = inSearch.substr(1).split("&");
		for (param in allArray)
		{
			var paramArray = allArray[param].split("=");
			q[ paramArray[0] ] = paramArray[1];
		}
		
		argvHash = q;
	}
	else
	{
		return;
	}
	
	if( q["horizontalGrid"] && checkNumInRange(q["horizontalGrid"], 1, 9999) ){ gridYoko = parseInt( q["horizontalGrid"],10); }
	if( q["verticalGrid"] && checkNumInRange(q["verticalGrid"], 1, 9999) ){ gridTate = parseInt( q["verticalGrid"],10); }
	
	if( q["horizontalCellNum"] && checkNumInRange(q["horizontalCellNum"], 2, 24) ){ tateNum = parseInt( q["horizontalCellNum"],10); }
	if( q["verticalCellNum"] && checkNumInRange(q["verticalCellNum"], 2, 24) ){ yokoNum = parseInt( q["verticalCellNum"],10); }
	
	if( q["cellWidth"] && checkNumInRange(q["cellWidth"], 4, 1000) ){ cellWidth = parseInt( q["cellWidth"],10); }
	if( q["cellHeight"] && checkNumInRange(q["cellHeight"], 4, 1000) ){ cellHeight = parseInt( q["cellHeight"],10); }

	if( q["tableWidth"] && checkNumInRange(q["tableWidth"], 60, 1600) ){ tableWidth = parseInt( q["tableWidth"],10); }
	if( q["tableHeight"] && checkNumInRange(q["tableHeight"], 60, 1000) ){ tableHeight = parseInt( q["tableHeight"],10); }

	if( q["shortcutWidth"] && checkNumInRange(q["shortcutWidth"], 4, 1000) ){ shortcutWidth = parseInt( q["shortcutWidth"],10); }
	if( q["shortcutHeight"] && checkNumInRange(q["shortcutHeight"], 4, 1000) ){ shortcutHeight = parseInt( q["shortcutHeight"],10); }
	
	if( q["screenNum"] && checkNumInRange(q["screenNum"], 1, 1000) ){ screenNum = parseInt( q["screenNum"],10); }	
	
	if( q["isPresetButtonToIcon"] ){ isPresetButtonToIcon = parseInt( q["isPresetButtonToIcon"],10); }	

	
	
	var userCommandLastIndex = 9;
	if( q["userCommandLastIndex"] && checkNumInRange(q["userCommandLastIndex"], 1, 1000) ){ userCommandLastIndex = parseInt( q["userCommandLastIndex"],10); }	
	
	for( var i = 1 ; i<= userCommandLastIndex ; i++ )
	{
		if( q["userTitle"+i] && q["userSize"+i] )
		{
			var size = decodeURIComponent( q["userSize"+i] );
			var title = decodeURIComponent(q["userTitle"+i]);
			var isAdd = 0;
			if( isPresetButtonToIcon || title.match(/_$|^_/i) )
			{
				var html = makeSizeToTable(size);
				if( html != "" )
				{
					var theClassAppend = "";
					if( ! html.match(/class=historyScreen/) )
					{
						theClassAppend = "NoScreen";
					}
					
					userCommandHTML += '<li class="userSizeIcon'+theClassAppend+'" onclick="doCommand(\'registHistory:NO\'); doCommand(\''+size+'\')">'+html+'</li>';
					isAdd = 1;
				}
			}

			if( isAdd == 0 )
			{
				userCommandHTML += '<li class="userSize" onclick="doUserSizeCommand('+i+')">'+htmlspecialchars(title)+'</li>';
			}
		}
	}
	
	var historyLastIndex = 9;
	if( q["historyLastIndex"] && checkNumInRange(q["historyLastIndex"], 1, 1000) ){ historyLastIndex = parseInt( q["historyLastIndex"],10); }	
	
	for( var i = 1 ; i<= historyLastIndex ; i++ )
	{
		if( q["historySize"+i] )
		{
			var size = decodeURIComponent( q["historySize"+i] );
			var html = makeSizeToTable(size);
			if( html != "" )
			{
				var theClassAppend = "";
				if( ! html.match(/class=historyScreen/) )
				{
					theClassAppend = "NoScreen";
				}
				
				historyHTML += '<li class="historyItem'+theClassAppend+'" onclick="doCommand(\'registHistory:YES\'); doCommand(\''+size+'\')">'+html+'</li>';
			}
		}
	}
	//userCommandHTML += "<li id='endBox'></li>";
	
	//if( q["userTitle3"] && q["userSize3"] ){ $("#userTitle3").text( decodeURIComponent(q["userTitle3"]) ); }else{ $("#userTitleBox3").text(""); }
	//if( q["userTitle4"] && q["userSize4"] ){ $("#userTitle4").text( decodeURIComponent(q["userTitle4"]) ); }else{ $("#userTitleBox4").text(""); }

}

function makeHistoryTable( size )
{
	try
	{
		var sizeArray = size.split(":")[1].split(",");
	}
	catch(e)
	{
		return "";
	}
	
	if( sizeArray.length < 5 )
	{
		return "";
	}
	
	var historyYokoNum = sizeArray[0];
	var historyTateNum = sizeArray[1];
	var x  = sizeArray[2];
	var y  = sizeArray[3];
	var x2 = sizeArray[4];
	var y2 = sizeArray[5];
		
	var screen = '';
	if( sizeArray[6] )
	{
		screen = sizeArray[6].toUpperCase();
		if( screen == "AUTO" || screen == "A" )
		{
			screen = "";
		}
		else if( screen == "NEXT" || screen == "N" )
		{
			screen = "N";
		}
		else if( screen == "PREV" || screen == "P" )
		{
			screen = "P";
		}
	}
	
	

	var html = "<table class='tableBox'><tr><td><table class='history'>"; // width="+shortcutWidth+" height="+shortcutHeight+"
	
	var yoko1CellPercent = (100.0/historyYokoNum);
	var tate1CellPercent = (100.0/historyTateNum);
	
	var yoko1CellSize = Math.round(shortcutWidth/historyYokoNum);
	var tate1CellSize = Math.round(shortcutHeight/historyTateNum);
	
	if( yoko1CellSize <= 0 )
	{
		yoko1CellSize = 1;
	}
	
	if( tate1CellSize <= 0 )
	{
		tate1CellSize = 1;
	}

	for( i = 0 ; i< historyTateNum ; i++ )
	{
		var tateClass = '';
		
		html += "<tr>";
		 for( n = 0 ; n < historyYokoNum ; n++ )
		 {
		 	var tdClass = tateClass;
			 
			 if( y <= i && i <= y2 && x <= n && n <= x2 )
			 {
			 	tdClass += "selected";
			 }
		 
		 	//html += "<td class='"+tdClass+"' width="+cellWidth+" height="+cellHeight+">";
			//html += "<td class='"+tdClass+"' width='"+yoko1CellPercent+"%' height='"+tate1CellPercent+"%'>";
			html += "<td class='"+tdClass+"' width='"+yoko1CellSize+"' height='"+tate1CellSize+"'>";
			//html += "<td class='"+tdClass+"'" +">";
			html += "&nbsp;";
			html += "</td>";
		 }
		 html += "</tr>";
	}
	
	html += "</table></td>";
	
	if( screen != "" )
	{
		html += "<td><span class=historyScreen>" + screen + "</span></td>";
	}
	
	html += "</tr></table>";
	
	return html;
}




function makeSizeToTable( size )
{
	try
	{
		var sizeTextArray = size.split(":")[1].split("&");
	}
	catch(e)
	{
		return "";
	}
	
	var sizeArray = sizeTextArray[0].split(",");
	if( sizeArray.length < 5 )
	{
		return "";
	}
	
	var historyYokoNum = sizeArray[0];
	var historyTateNum = sizeArray[1];
	var screen = "";
	if( sizeArray[6] )
	{
		screen = sizeArray[6].toUpperCase();
	}
	
	var html = "<table class='tableBox'><tr><td valign=middle><table class='history'>"; // width="+shortcutWidth+" height="+shortcutHeight+"
		
	var yoko1CellPercent = (100.0/historyYokoNum);
	var tate1CellPercent = (100.0/historyTateNum);
	
	var yoko1CellSize = Math.round(shortcutWidth/historyYokoNum);
	var tate1CellSize = Math.round(shortcutHeight/historyTateNum);
	
	if( yoko1CellSize <= 0 )
	{
		yoko1CellSize = 1;
	}
	
	if( tate1CellSize <= 0 )
	{
		tate1CellSize = 1;
	}
	
	if( sizeTextArray.length > 6 )	//これ以上CSSがない
	{
		return "";
	}
	
	var x = [];
	var y  = [];
	var x2 = [];
	var y2 = [];
		
	for( var si = 0 ; si < sizeTextArray.length ; si++ )
	{
		var sizeArray = sizeTextArray[si].split(",");
		if( sizeArray.length < 5 )
		{
			return "";
		}
		
		var curYokoNum = sizeArray[0];
		var curTateNum = sizeArray[1];
		x[si]  = sizeArray[2];
		y[si]  = sizeArray[3];
		x2[si] = sizeArray[4];
		y2[si] = sizeArray[5];
		
		if( curYokoNum != historyYokoNum || curTateNum != historyTateNum )
		{
			return "";
		}
		
		var curScreen = '';
		if( sizeArray[6] )
		{
			curScreen = sizeArray[6].toUpperCase();
			if( curScreen != screen )
			{
				return "";
			}
		}	
	}
		

	for( i = 0 ; i< historyTateNum ; i++ )
	{
		var tateClass = '';
		
		html += "<tr>";
		 for( n = 0 ; n < historyYokoNum ; n++ )
		 {
			 var tdClass = tateClass;
			 
			 for( si= 0 ; si < sizeTextArray.length ; si++ )
			 {
			 	
			 	if( y[si] <= i && i <= y2[si] && x[si] <= n && n <= x2[si] )
				{
					if( tdClass != "" )
					{	//重なっている場合
						return "";
					}
					 if( y[si] == y2[si] && x[si] == x2[si] )
					{
						 tdClass += "move";
					 }
					 else
					 {
					 	tdClass += "selected" + (si+1);
			 		}
				}
		 	}
			 
			 //html += "<td class='"+tdClass+"' width="+cellWidth+" height="+cellHeight+">";
			//html += "<td class='"+tdClass+"' width='"+yoko1CellPercent+"%' height='"+tate1CellPercent+"%'>";
			html += "<td class='"+tdClass+"' width='"+yoko1CellSize+"' height='"+tate1CellSize+"'>";
			//html += "<td class='"+tdClass+"'" +">";
			html += "&nbsp;";
			html += "</td>";
		 }
		 html += "</tr>";
	}
	
	html += "</table></td>";
	
	if( screen != "" )
	{
		if( screen == "AUTO" || screen == "A" )
		{
			screen = "";
		}
		else if( screen == "NEXT" || screen == "N" )
		{
			screen = "N";
		}
		else if( screen == "PREV" || screen == "P" )
		{
			screen = "P";
		}
		
		html += "<td  valign=middle><span class=historyScreen>" + screen + "</span></td>";
	}
	
	html += "</tr></table>";
	
	return html;
}


function changeScreen2( screen )
{
	$(".screenButton2").removeClass("screenButton2On");
	$("#screenButton"+screen).addClass("screenButton2On");
	selectScreen = screen;
}

function changeScreen()
{
	var currentValue = $("#screenButton").text();
	var setValue = "";
	
	if( currentValue == "A" )
	{
		 setValue = "N";
	}
	else if( currentValue == "N" )
	{
		if( screenNum >= 3 )
		{
			setValue = "P";
		}
		else
		{
			setValue = "1";
		}
	}
	else if( currentValue == "P" )
	{
		setValue = "1";
	}
	else
	{
		var screenIndex = parseInt(currentValue,10);
		screenIndex += 1;
		if( screenIndex > screenNum)
		{
			setValue = "A";
		}
		else
		{
			setValue = "" + screenIndex;
		}
	}
	
	$("#screenButton").text(setValue);
}

function doUserSizeCommand( commandNo )
{
	var size = argvHash[ 'userSize'+commandNo ];
	if( size  )//&& size.match(/^size\:/)
	{
		size = decodeURIComponent(size);
		doCommand(size);
	}
	else
	{
		closeWindow();
	}
}

function log(msg)
{
	//$('#log').text(msg);
	
	//var obj1 = new Image();	obj1.src = msg;
}

function preLoadImage( url )
{
	var obj1 = new Image();
	obj1.src = url;
}

function doCommand(cmd)
{
	var screen = selectScreen.toLowerCase();//$("#screenButton").text().toLowerCase();
	if( shortScrrenNameToLongScreenNameHash[screen] )
	{
		screen = shortScrrenNameToLongScreenNameHash[screen];
	}
	
	if( screenNum >= 2 && cmd.match(/^size\:/) && screen != "auto" )
	{
		cmd = cmd.replace(/((?:&|\:)\d+,\d+,\d+,\d+,\d+,\d+)(?=&|$)/gi, "$1," + screen  );
	}
	
	var obj1 = new Image();
	obj1.src = cmd;
	
	//alert(cmd);
}

	// http://dynamic-tools.net/toolbox/isMouseLeaveOrEnter/
function isMouseLeaveOrEnter(e, handler)
{		
	var reltg = e.relatedTarget ? e.relatedTarget : e.type == 'mouseout' ? e.toElement : e.fromElement;
	while (reltg && reltg != handler) reltg = reltg.parentNode;
	return (reltg != handler);
}
			
function checkNumInRange( n, min, max )
{
	n = parseInt( n,10);
	if( min <= n && n <= max )
	{
		return true;
	}
	
	return false;
}


function mouseoutSelectTableAction()
{

	if( isDrag == false )
	{
		//doCommand('closewindow://closewindow');	
		for(y2 = 0; y2 < objList.length; y2++){
		for(x2 = 0; x2 < objList[y2].length; x2++){
		objList[y2][x2].style.backgroundColor = cellDefaultColor;
		}
		}
	}


}

function mouseoverSelectTableAction()
{
	//clearColorToDontActionTimmer();
}

function mouseoverAction()
{
	clearCloseTimmer();
	clearColorToDontActionTimmer();
}

function closeWindow()
{
	log("f://closeWindow");
	doCommand('closewindow://closewindowfunction');
}

function clearCloseTimmer()
{
	log("f://clearCloseTimmer");
	clearTimeout(closeTimmer);
	closeTimmer = 0;
	
	for(y2 = 0; y2 < objList.length; y2++){
	for(x2 = 0; x2 < objList[y2].length; x2++){
	objList[y2][x2].style.backgroundColor = cellDefaultColor;
	}
	}
}

function clearColorToDontActionTimmer()
{
	clearTimeout(colorToDontActionTimmer);
	colorToDontActionTimmer = 0;
}

function colorToDontAction()
{
	isDoResizeAction = false;

clearTimeout(colorToDontActionTimmer);
colorToDontActionTimmer = 0;

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
objList[y2][x2].style.backgroundColor = cellCancelColor;
}
}

}

function mouseoutAction()
{
	log("mouseoutAction://");
if( isDrag == false )
{
	//doCommand('closewindow://closewindow');
	
	clearCloseTimmer();
	closeTimmer = setTimeout("closeWindow()", checkTime);
	
	for(y2 = 0; y2 < objList.length; y2++){
	for(x2 = 0; x2 < objList[y2].length; x2++){
	objList[y2][x2].style.backgroundColor = cellCancelColor;
	}
	}
}
else
{
	clearColorToDontActionTimmer();
	colorToDontActionTimmer = setTimeout("colorToDontAction()", checkTime);
}


}
			
function initWindowSize()
{
	var menuWidth = window.outerWidth - window.innerWidth;
	var menuHeight = window.outerHeight - window.innerHeight;
			
	var dialog = document.getElementById( 'main' );
	
	var newWidth = dialog.clientWidth+menuWidth+0;
	var newHeight = dialog.clientHeight+menuHeight+0;

	//alert(''+newWidth+","+newHeight);
	window.resizeTo(newWidth, newHeight); 
}

function tellSelectedArea()
{
	if(startX>endX)
	{
		var tmp = startX;
		startX = endX;
		endX = tmp;
	}

	if(startY>endY)
	{
		var tmp = startY;
		startY = endY;
		endY = tmp;
	}
	
	//alert("start:"+startX+","+startY+" end:"+endX+","+endY);
	
	doCommand("registHistory:YES");
	doCommand("size:"+yokoNum+","+tateNum+","+startX+","+startY+","+endX+","+endY);
	//location.href= "size:"+yokoNum+","+tateNum+","+startX+","+startY+","+endX+","+endY;
}

function initTable_yokutsukau()
{
	var halfWidth = Math.floor( shortcutWidth / 2 );
	var halfHeight = Math.floor( shortcutHeight / 2 );
	
	addStyleRule( ".fullWidth { width: "+shortcutWidth+"px  !important; }" );
	addStyleRule( ".fullHeight { height: "+shortcutHeight+"px  !important; }" );
	addStyleRule( ".halfWidth { width: "+halfWidth+"px  !important; }" );
	addStyleRule( ".halfHeight { height: "+halfHeight+"px  !important; }" );
	addStyleRule( ".fullWidth { width: "+shortcutWidth+"px  !important; }" );
	addStyleRule( ".fullHeight { height: "+shortcutHeight+"px  !important; }" );
}

function initTable()
{
	var html = "";
	
	var yoko1CellPercent = (100.0/yokoNum);
	var tate1CellPercent = (100.0/tateNum);

	for( i = 1 ; i<= tateNum ; i++ )
	{
		var tateClass = '';
		
		if( (i % gridTate) == 0 )
		{
			tateClass += " gridBottom";
		}
		
		html += "<tr>";
		 for( n = 1 ; n <= yokoNum ; n++ )
		 {
		 	var tdClass = tateClass;
			 
			 if( (n% gridYoko) == 0 )
			{
				tdClass += " gridRight";
			}
		 
		 	//html += "<td class='"+tdClass+"' width="+cellWidth+" height="+cellHeight+">";
			html += "<td class='"+tdClass+"' width='"+yoko1CellPercent+"%' height='"+tate1CellPercent+"%'>";
			//html += "<td class='"+tdClass+"'" +">";
			html += "&nbsp;";
			html += "</td>";
		 }
		 html += "</tr>";
	}
	
	$('#selectBody').html(html);
}



function initSelect(){
// http://oshiete.goo.ne.jp/qa/3871770.html
var x, y;
var objTable = document.getElementById("selectTable");
var objTrList = objTable.getElementsByTagName("tr");


//document.getElementById("main").onmouseout="if (isMouseLeaveOrEnter(event, this)){mouseoutAction()}";
//document.getElementById("main").onmouseover="if (isMouseLeaveOrEnter(event, this)){ mouseoverAction();}";

window.onmouseup =  function(){
	if( ! isReadyTable ){ return; }
	
	if( isDoResizeAction && isDrag )
	{
		tellSelectedArea();
	}
	else if( isDrag )
	{
		for(y2 = 0; y2 < objList.length; y2++){
			for(x2 = 0; x2 < objList[y2].length; x2++){
				objList[y2][x2].style.backgroundColor = cellDefaultColor;
			}
		}
		isDrag = 0;
		
		//log("mouseup");
		doCommand('closewindow://window.onmouseup');	//終了する。
	}
};

// Y軸をループ
for(y = 0; y < objTrList.length; y++){
// objListを初期化していく
objList[y] = objTrList[y].getElementsByTagName("td");

// X軸をループ
for(x = 0; x < objList[y].length; x++){
// セルにXとYの座標を保持
objList[y][x].x = x;
objList[y][x].y = y;
// セルに背景色を保持
objList[y][x].color = cellDefaultColor;



objList[y][x].onmouseup = function(){
if( ! isReadyTable ){ return; }

if(isDrag){
var x2, y2;

endX = this.x;
endY = this.y;
tellSelectedArea();

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
if(isSelect(objList[y2][x2], this.x, this.y)){
objList[y2][x2].style.backgroundColor = cellColor;
objList[y2][x2].color = cellColor;
}
}
}
isDrag = false;
}
}


// クリックしたときの処理
objList[y][x].onmousedown = function(){
if( ! isReadyTable ){ return; }

isDoResizeAction = true;
clearCloseTimmer();
clearColorToDontActionTimmer();

if(isDrag){
var x2, y2;

endX = this.x;
endY = this.y;
tellSelectedArea();

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
if(isSelect(objList[y2][x2], this.x, this.y)){
objList[y2][x2].style.backgroundColor = cellColor;
objList[y2][x2].color = cellColor;
}
}
}
isDrag = false;
}else{
// ドラッグ開始
startX = this.x;
startY = this.y;
isDrag = true;
}
}

// ドラッグ中の処理
objList[y][x].onmouseover = function(){
if( ! isReadyTable ){ return; }

clearCloseTimmer();
clearColorToDontActionTimmer();
isDoResizeAction = true;

// ドラッグ中でない場合は終了
if(!isDrag){ 
//hoverでハイライト　動かないアプリが多いので停止 //理由が分かった
for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
objList[y2][x2].style.backgroundColor = cellDefaultColor;
}
}
this.style.backgroundColor = dragColor;


return; }

// ドラッグ中は背景色を変更する
var x2, y2;

endX = this.x;
endY = this.y;

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
if(isSelect(objList[y2][x2], this.x, this.y)){
objList[y2][x2].style.backgroundColor = dragColor;
}else{
objList[y2][x2].style.backgroundColor = objList[y2][x2].color;
}
}
}
}
}
}
}

// 指定セルが、ドラッグの範囲かどうかを判定する
function isSelect(obj, x, y){
var flgX, flgY;

// 左右の判定
if(x >= startX){
flgX = (startX <= obj.x && obj.x <= x);
}else{
flgX = (x <= obj.x && obj.x <= startX);
}

// 上下の判定
if(y >= startY){
flgY = (startY <= obj.y && obj.y <= y);
}else{
flgY = (y <= obj.y && obj.y <= startY);
}

return (flgX && flgY);
}


function changeColor(obj){
var color = obj.options[obj.selectedIndex].style.backgroundColor;
obj.style.backgroundColor = color;
cellColor = color;
}



function htmlspecialchars(ch) { 
ch = ch.replace(/&/g,"&amp;") ;
ch = ch.replace(/"/g,"&quot;") ;	//"
ch = ch.replace(/'/g,"&#039;") ;	//'
ch = ch.replace(/</g,"&lt;") ;
ch = ch.replace(/>/g,"&gt;") ;
return ch ;
}


function htmlspecialcharsDecode(ch) { 
ch = ch.replace(/&quot;/g,'"') ;	//"
ch = ch.replace(/&#039;/g,"'") ;	//'
ch = ch.replace(/&lt;/g,"<") ;
ch = ch.replace(/&gt;/g,">") ;
ch = ch.replace(/&nbsp;/g," ") ;
ch = ch.replace(/&amp;/g,"&") ;
return ch ;
}

function addStyleRule( inStyle )
{
	var element = document.createElement('style');
	element.type= 'text/css';
	
	var textNode = document.createTextNode( inStyle );
	//element.innerHTML = inStyle;
	element.appendChild( textNode );
	
	document.getElementsByTagName('head')[0].appendChild(element);
}

//objの縦横の位置を取得
//From http://www.quirksmode.org/js/findpos.html
function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}

